/******************************************************************************
 *
 *	Pocket Balloon
 *	color edition
 *	PalmOS 5
 *	ver 1.1.0
 *	2008. 4
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#defien NOMAL
//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/



/************************************************
 *	XN[̏
 ***********************************************/
Err
init_screen( void )
{
  UInt16 error;
  UInt32 width = 160, height = 160, depth = 8;
  Boolean color;


  // J[T|[gĂ邩
  WinScreenMode( winScreenModeGet, NULL, NULL, NULL, &color );
  if( ! color )
    return -1;

  WinScreenMode( winScreenModeGet,
                 &g_save_screen.width,
                 &g_save_screen.height,
                 &g_save_screen.depth,
                 NULL );
  WinScreenMode( winScreenModeSet, &width, &height, &depth, NULL );

  // obNXN[쐬
  g_back_screen_h = WinCreateOffscreenWindow( BACK_WIDTH, BACK_HEIGHT,
                                              screenFormat, &error );
  ErrFatalDisplayIf( error, "Error Allocating Offscreen" );

  // XN[NA
  clear_screen();

  return errNone;
}



/************************************************
 *	obNXN[LCDɃRs[
 ***********************************************/
void
copy_buff_to_lcd( void )
{
  RectangleType r;


  r.topLeft.x = 16, r.topLeft.y = 16, r.extent.x = 160, r.extent.y = 160;
  WinCopyRectangle( g_back_screen_h, NULL, &r, 0, 0, winPaint );
}



/************************************************
 *	SʃNA
 ***********************************************/
void
clear_screen( void )
{
  WinSetDrawWindow( g_back_screen_h );
  WinPushDrawState();
  WinSetBackColor( INDEX_BLACK ); // wi

  WinEraseWindow();

  WinPopDrawState();
  WinSetDrawWindow( NULL );
}



/************************************************
 *	XvCg\iobNXN[j
 *	n*nhbg 8bit XvCg
 ***********************************************/
void
sprite( Coord x, Coord y, WinHandle chr_no )
{
  RectangleType r;


  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return;

  WinGetBounds( chr_no, &r );

  WinCopyRectangle( chr_no, g_back_screen_h, &r, x, y, winPaint );
}



/************************************************
 *	PSETiobNXN[j
 ***********************************************/
void
pset( Coord x, Coord y, IndexedColorType col )
{
  // ͈̓`FbN
  if( (UInt16) x >= 160+BACK_W_BLANK || (UInt16) y >= 160+BACK_H_BLANK )
    return;

  WinSetDrawWindow( g_back_screen_h );
  WinPushDrawState();
  WinSetForeColor( col );

  WinDrawPixel( x, y );

  WinPopDrawState();
  WinSetDrawWindow( NULL );
}



