/******************************************************************************
 *
 *	Pocket Balloon
 *	color edition
 *	PalmOS 5
 *	ver 1.1.0
 *	2008. 4
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/

// ʉf[^
// [D揇] [f[^] [ms] [gHz], [t[] JԂ
static int g_se_data[ sound_cnt ][ SND_LENGTH ] =
{
  { 0 }	,									// no_sound
  { 1, 2, 10, 349, 392 },							// jump	: F/G
  { 2, 6, 38, 311, 311, 311, 277, 277, 277 },					// bound: D#/C#
  { 3, 6, 38, 415, 415, 554, 554, 622, 622 },					// balloon: G#/C#/D#
  { 4, 12, 38, 523, 523, 523, 659, 659, 659, 784, 784, 784, 988, 988, 988 },	// bonus: C/E/G/B
  { 5, 6, 38, 196, 196, 196, 196, 196, 196 },					// thorn: G
  { 6, 1, 38, 440 },								// tick: A
  { 7, 12, 38, 415, 415, 415, 392, 392, 392, 349, 349, 349, 311, 311, 311 },	// over: Ab/G/F/Eb
  { 100, 1, 38, 440 },								// click: A
};



/************************************************
 *	SEIIt؂芷
 ***********************************************/
void
change_se( void )
{
  // ̈攻{L[
  if( g_gs.pen_down && !g_gs.pen_move && g_gs.pen_y < 16+BACK_H_BLANK
      || g_gs.keyf == KEY_DOWN )
    {
      g_gs.sound ^= 1;
      g_gs.pen_down = false;
      set_se( click );
    }
}



/************************************************
 *	ʉZbg
 ***********************************************/
void
set_se( SoundType type )
{
  if( g_se_data[ type ][0] >= g_se_data[ g_gs.se ][0] )
    {
      g_gs.se = type;
      g_gs.se_repeat = 0;
    }
}



/************************************************
 *	ʉ
 ***********************************************/
void
sound( void )
{
  SndCommandType cmd;


  if( g_gs.se != no_sound && g_gs.sound )
    {
      cmd.cmd = sndCmdFrqOn;
      cmd.param1 = g_se_data[ g_gs.se ][ 3 + g_gs.se_repeat ];
      cmd.param2 = g_se_data[ g_gs.se ][2];
      cmd.param3 = g_volume;

      SndDoCmd( NULL, &cmd, true );

      if( ++g_gs.se_repeat >= g_se_data[ g_gs.se ][ 1 ] )
        g_gs.se = no_sound;
    }
}



/********************************************************************
 *	X^[eBbNȊ֐Q
 *******************************************************************/



